#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
require("dotenv").config();
require("ts-node/register/transpile-only");
var auth_app_1 = require("@octokit/auth-app");
var typescript_1 = require("./typescript");
var tslint_1 = require("./tslint");
var path = __importStar(require("path"));
var TSLINT_CHECK_APP_ID = 42099;
require("yargs")
    .usage("$0 <tsconfig>", "Get Typescript and TSLint diagnostics for the Typescript project and post results as a \"check run\" to the given GitHub repository.\n\n  The following environment variables, corresponding to a GitHub app with 'checks:write' permission, are used to authenticate with the GitHub API:\n\n  GITHUB_APP_PRIVATE_KEY\n  GITHUB_APP_INSTALLATION_ID\n  GITHUB_APP_CLIENT_ID\n  GITHUB_APP_CLIENT_SECRET\n\n  They can also be provided in a \".env\" file in the current working directory.", function (yargs) {
    yargs.positional('tsconfig', {
        describe: 'Path to the TypeScript project configuration file',
        type: 'string',
        default: path.join(process.cwd(), 'tsconfig.json')
    })
        .option('repo', {
        describe: 'The github repository, "owner/repo"',
        demandOption: true,
        type: 'string'
    })
        .demand(['repo']);
}, function (argv) {
    var tsConfigFile = argv.tsconfig;
    var _a = argv.repo.split("/"), owner = _a[0], repo = _a[1];
    if (!owner || !repo) {
        console.error("Invalid --repo argument " + argv.repo + ". Expected \"owner/repo\".");
        process.exit(1);
    }
    process.exit();
    runChecks({ tsConfigFile: tsConfigFile, repo: repo, owner: owner }).catch(function (e) {
        console.error(e);
        process.exit(1);
    });
})
    .help("help")
    .argv;
function runChecks(options) {
    return __awaiter(this, void 0, void 0, function () {
        var tsConfigFile, repo, owner, github;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    tsConfigFile = options.tsConfigFile, repo = options.repo, owner = options.owner;
                    return [4 /*yield*/, authenticate()];
                case 1:
                    github = _a.sent();
                    return [2 /*return*/, Promise.all([
                            typescript_1.typescriptCheck(github, { owner: owner, repo: repo, tsConfigFile: tsConfigFile }),
                            tslint_1.tslintCheck(github, { owner: owner, repo: repo, tsConfigFile: tsConfigFile })
                        ])];
            }
        });
    });
}
function authenticate() {
    return __awaiter(this, void 0, void 0, function () {
        var auth, installationAuthentication, octokit;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    auth = auth_app_1.createAppAuth({
                        id: TSLINT_CHECK_APP_ID,
                        privateKey: process.env.GITHUB_APP_PRIVATE_KEY || "",
                        installationId: Number(process.env.GITHUB_APP_INSTALLATION_ID),
                        clientId: process.env.GITHUB_APP_CLIENT_ID,
                        clientSecret: process.env.GITHUB_APP_CLIENT_SECRET
                    });
                    return [4 /*yield*/, auth({ type: "installation" })];
                case 1:
                    installationAuthentication = _a.sent();
                    octokit = require("@octokit/rest");
                    return [2 /*return*/, new octokit({
                            auth: installationAuthentication.token
                        })];
            }
        });
    });
}
